
#include <iostream>
#include <iomanip>
#include <sstream>
#include <cstdlib>
#include <cstring>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include "PNG.hh"
#include "seq.hh"

seq::seq( const char* _prefix, unsigned int _fill, const char* _suffix ) {
    this->prefix = _prefix;
    this->fill = _fill;
    this->suffix = _suffix;

    bool done = false;
    for ( this->count = 0; !done; ++this->count ) {
	char fname[ MAXPATHLEN+1 ];
	this->filename( this->count, fname, sizeof(fname) );
	done = ! this->exists( fname );
    }

    --this->count;

    this->pngs = new PNG[ this->count ];
}

seq::~seq( void ) {
    delete[] this->pngs;
}

unsigned char* seq::getBuffer( unsigned int _index ) {
    unsigned char* ret = 0;

    if ( _index >= this->count ) {
	_index = this->count - 1;
    }

    ret = this->pngs[ _index ].getBuffer();

    if ( ret == 0 ) {
	char fname[ MAXPATHLEN+1 ];
	this->filename( _index, fname, sizeof(fname) );
	if ( ! this->pngs[ _index ].read( fname ) ) {
	    std::cerr << "PNG READ FAILED: " << fname << std::endl;
	    std::exit( __LINE__ );
	} else {
	    ret = this->pngs[ _index ].getBuffer();
	}
    }

    return ret;
}

void seq::filename( unsigned int _index, char _buf[], unsigned int _len ) const{
    std::ostringstream str;

    str << this->prefix
	<< std::setfill( '0' ) 
	<< std::setw( this->fill ) 
	<< ( _index + 1 )
	<< this->suffix
	<< std::ends;

    std::strncpy( _buf, str.str().c_str(), _len );
}

bool seq::exists( const char* _filename ) const {
    struct stat sbuf;
    return ( ::stat( _filename, &sbuf ) == 0 );
}
