
#include <cmath>

#include "vec.hh"

vec::vec( void ) {
}

vec::vec( double _xx, double _yy, double _zz, double _tt ) {
    this->set( _xx, _yy, _zz, _tt );
}

vec::vec( const vec& _orig ) {
    this->set( _orig.xx, _orig.yy, _orig.zz, _orig.tt );
}

vec& vec::operator = ( const vec& _orig ) {
    this->set( _orig.xx, _orig.yy, _orig.zz, _orig.tt );
    return *this;
}

vec& vec::operator += ( const vec& _oo ) {
    this->xx += _oo.xx;
    this->yy += _oo.yy;
    this->zz += _oo.zz;
    this->tt += _oo.tt;
}

vec& vec::operator *= ( double _ss ) {
    this->xx *= _ss;
	this->yy *= _ss;
	this->zz *= _ss;
	this->tt *= _ss;
    return *this;
}

void vec::normalize( void ) {
    double vv = this->dot( *this );

    if ( vv > 0.0001 ) {
	*this *= 1.0 / std::sqrt( vv );
    }
}

double vec::dot( const vec& _other ) const {
    return this->xx * _other.xx
	+ this->yy * _other.yy
	+ this->zz * _other.zz
	+ this->tt * _other.tt
	;
}

void vec::set( double _xx, double _yy, double _zz, double _tt ) {
    this->xx = _xx;
    this->yy = _yy;
    this->zz = _zz;
    this->tt = _tt;
}

std::ostream& operator << ( std::ostream& _oo, const vec& _vv ) {
    _oo << "< " << _vv.getX() << ", "
	<< _vv.getY() << ", "
	<< _vv.getZ() << ", "
	<< _vv.getT() << " >"
	;
    return _oo;
}
