#include <ostream>

class vec {
public:
    vec( void );
    vec( double _xx, double _yy, double _zz, double _tt );
    vec( const vec& _orig );

    vec& operator = ( const vec& _orig );

    vec& operator += ( const vec& _oo );
    vec& operator *= ( double _ss );

    void normalize( void );

    double dot( const vec& _other ) const;

    inline double getX( void ) const { return this->xx; };
    inline double getY( void ) const { return this->yy; };
    inline double getZ( void ) const { return this->zz; };
    inline double getT( void ) const { return this->tt; };

private:
    void set( double _xx, double _yy, double _zz, double _tt );

private:
    double xx;
    double yy;
    double zz;
    double tt;
};

std::ostream& operator << ( std::ostream& _oo, const vec& _vv );
